module Behaviour(Trace(..),(+++),approx,cut) where

infixr 2 :>

data Trace a
  = Step (Trace a)
  | a :> Trace a
  | End
  | Crash
  | Cut
  deriving (Eq, Show)

(+++) :: Trace a -> Trace a -> Trace a
Step s   +++ t = Step (s +++ t)
(x :> s) +++ t = x :> (s +++ t)
End      +++ t = t
Crash    +++ t = Crash
Cut      +++ _ = Cut

cut :: Integer -> Trace a -> Trace a
cut 0 _ = Cut
cut n (a :> s) = a :> cut (n - 1) s
cut n (Step s) = Step $ cut (n - 1) s
cut n Crash    = Crash
cut n End      = End
cut n Cut      = Cut

approx :: Eq a => Integer -> Trace a -> Trace a -> Bool
approx n s t = cut n s == cut n t

